﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using SlimDX.DirectInput; // a direct x wrapper for c# added to the references
using System.Net.Sockets; // for tcp
using System.Net; // for tcp

namespace PT
{
    public partial class PTC : Form
    {
        // globals for FPT mode
        private bool FPTmode = false;
        byte[] bit8 = new byte[2];

        public PTC()
        {
            InitializeComponent();
            //initPoints();
            //openSerial();
            initJoystick();
            initTCP();
        }
        ~PTC()
        {
            serialPort1.Close();
            destructTCP();
        }

        /*
        //a multithreaded function, this method runs in a new thread
        // everytime its called, it opens another thread running this method
        // use a bool if only wanted to run once until done
        private bool ready = true;
        private int threadCount = 0;
        delegate void slowBeauDelegate();
        private void slowBeau()
        {
            if (ready)
            {
                //while (true)
                //{
                ready = false;
                threadCount++;
                    //Thread.Sleep(1000);
                    richTextBox1.SelectionColor = Color.Blue;
                    richTextBox1.AppendText("\nSleeping" + threadCount);
                    richTextBox1.SelectionColor = Color.Black;
                    Thread.Sleep(1000);
                
                //}
                threadCount--;
                ready = true;
            }            
            //how to call this method:
            //slowBeauDelegate sb = new slowBeauDelegate(slowBeau);
            //sb.BeginInvoke(null, null);            
        }
        */
        
        //--button clicks-------------------------------------------------------------
        private void button1_Click(object sender, EventArgs e)
        {
            sendSerialLine = "s";
            sendSerialDelegate ss = new sendSerialDelegate(sendSerial);
            ss.BeginInvoke(null, null);
        }
        private void button3_Click(object sender, EventArgs e)
        {
            sendSerialLine = textBox3.Text;
            sendSerialDelegate ss = new sendSerialDelegate(sendSerial);
            ss.BeginInvoke(null, null);
        }
        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            string T = comboBox1.Text;
            /*
            char[] ta = new Char[10];
            for (int i = 0; i < T.Length-1; i++)
            {
                ta[i] = T[i];
            }
            T = ta.ToString();
            */
            sendSerialLine = T;
            sendSerialDelegate ss = new sendSerialDelegate(sendSerial);
            ss.BeginInvoke(null, null);
        }
        private void button7_Click(object sender, EventArgs e)
        {
            sendTCP();
        }
    }
}